#include<stdlib.h>
#include "types.h"
#include "warning.h"
#include "color.h"
#include "map.h"
#include "post.h"
#include "autopost.h"

void randomsmer (int *xx, int *yy)
{
  int smer;

  smer = rand()%8;

  if(smer > 3) smer++;

  if(xx) *xx = smer%3-1;
  if(yy) *yy = smer/3-1;
}

void auto_random (kq_postava *post)
{
  randomsmer(&post->xx, &post->yy);
}

void primosmer (int *xx, int *yy, int x, int y)
{
  if(x==0 && y==0){
    *xx = 0;
    *yy = 0;
    return;
  }

  if(xx){
    if(2*abs(x) > abs(y)){
      if(x > 0) *xx = 1;
      else *xx = -1;
    }
    else *xx = 0;
  }

  if(yy){
    if(2*abs(y) > abs(x)){
      if(y > 0) *yy = 1;
      else *yy = -1;
    }
    else *yy = 0;
  }
}

void auto_primo (kq_postava *post)
{
  int x, y;

  getchytsour(post, &x, &y);
  primosmer(&post->xx, &post->yy, x-post->x, y-post->y);
}

#define uvnitrmapy(x,y) (mapa && x>=0 && x<mapa->sirka && y>=0 && y<mapa->vyska)
#define jezed(x,y) (uvnitrmapy(x,y) && mapa->pole[x][y]->zed)

int vzdalenost (int x1, int y1, int x2, int y2)
{
  int vzd1, vzd2;

  vzd1 = abs(x1-x2);
  vzd2 = abs(y1-y2);
  if(vzd1 > vzd2) return vzd1;
  return vzd2;
}

int post_vzdal (kq_postava *p1, kq_postava *p2)
{
  return vzdalenost(p1->x, p1->y, p2->x, p2->y);
}

// smer : 1 = po smeru, -1 = proti smeru

static char obejdized (kq_postava *post, int x, int y, int xx, int yy,
		      int cilx, int cily, int *vzdal, int *delka,
		      int *nejxx, int *nejyy)
{
  int i;
  int usl, vzd, prvcil, poscil;
  int startx, starty, nxx, nyy;

  startx = x;
  starty = y;
  *nejxx = xx;
  *nejyy = yy;
  usl = 0;
  prvcil = poscil = 0;
  vzd = vzdalenost(x, y, cilx, cily);

  for(;;){
    if(jezed(x + (xx+yy), y + (yy-xx)) &&
       jezed(x + (yy), y + (-xx))){
      i = -xx;
      xx = yy;
      yy = i;
      if(!usl) break;
    }
    else{
      if(jezed(x + (xx+yy), y + (yy-xx))){
	x += yy;
	y += -xx;
      }
      else{
	x += xx+yy;
	y += yy-xx;
	i = xx;
	xx = -yy;
	yy = i;
      }
      usl++;
      if((x == startx && y == starty) || !uvnitrmapy(x,y)) break;
      i = vzdalenost(x, y, cilx, cily);
      if(i < vzd){
	vzd = i;
	prvcil = poscil = usl;
      }
      else if(i == vzd){
	poscil = usl;
      }
    }
  }

  if(uvnitrmapy(x,y)){
    *vzdal = vzd;
    if(prvcil == 0){
      *delka = 0;
      return 0;
    }
    else if(prvcil <= usl-poscil){
      *delka = prvcil;
      return 1;
    }
    else{
      *delka = usl-poscil;
      *nejxx = xx;
      *nejyy = yy;
      return -1;
    }
  }

  x = startx;
  y = starty;
  nxx = xx = *nejxx;
  nyy = yy = *nejyy;
  usl = 0;

  for(;;){
    if(jezed(x + (xx-yy), y + (yy+xx)) &&
       jezed(x + (-yy), y + (xx))){
      i = xx;
      xx = -yy;
      yy = i;
      if(!usl){
	nxx = xx;
	nyy = yy;
      }
    }
    else{
      if(jezed(x + (xx-yy), y + (yy+xx))){
	x += -yy;
	y += xx;
      }
      else{
	x += xx-yy;
	y += yy+xx;
	i = -xx;
	xx = yy;
	yy = i;
      }
      usl++;
      if(!uvnitrmapy(x,y)) break;
      i = vzdalenost(x, y, cilx, cily);
      if(i < vzd || (i == vzd && prvcil > usl)){
	vzd = i;
	prvcil = -usl;
      }
    }
  }

  *vzdal = vzd;
  if(prvcil == 0){
    *delka = 0;
    return 0;
  }
  else if(prvcil > 0){
    *delka = prvcil;
    return 1;
  }
  else{
    *delka = -prvcil;
    *nejxx = nxx;
    *nejyy = nyy;    
    return -1;
  }
}

void auto_clever (kq_postava *post)
{
  int i;
  int cilx, cily;
  int xx, yy, nxx, nyy, vzd, delka, smer;
  int nejvzd, nejdelka, nejxx, nejyy, nejsmer;

  if(jezed(post->x, post->y)) return;

  getchytsour(post, &cilx, &cily);
  xx = 0; yy = 1;
  nejvzd = -1;
  nejsmer = 0;
  do{
    if(jezed(post->x + xx, post->y + yy)){
      smer = obejdized(post, post->x, post->y, xx, yy, cilx, cily,
		       &vzd, &delka, &nxx, &nyy);
      if(nejvzd < 0 || vzd < nejvzd || (vzd == nejvzd && delka < nejdelka)){
	nejvzd = vzd;
	nejdelka = delka;
	nejxx = nxx;
	nejyy = nyy;
	nejsmer = smer;
	}
    }
    i = xx;
    xx = -yy;
    yy = i;
  } while(xx != 0 || yy != 1);

  if(nejsmer){
    if(!jezed(post->x + nejxx+nejsmer*nejyy, post->y + nejyy-nejsmer*nejxx)){
      post->xx = nejxx+nejsmer*nejyy;
      post->yy = nejyy-nejsmer*nejxx;
    }
    else{
      post->xx = nejsmer*nejyy;
      post->yy = -nejsmer*nejxx;
    }
    return;
  }

  primosmer(&post->xx, &post->yy, cilx-post->x, cily-post->y);
  if(jezed(post->x+post->xx, post->y+post->yy)){
    xx = (post->xx-post->yy)/2;
    yy = (post->xx+post->yy)/2;
    if(jezed(post->x+xx, post->y+yy)) return;
    smer = obejdized(post, post->x+xx, post->y+yy, -yy, xx, cilx, cily,
		     &vzd, &delka, &nxx, &nyy);
    if(smer <= 0){
      post->xx = xx;
      post->yy = yy;
    }
    else{
      post->xx = yy;
      post->yy = -xx;
    }
  }
}
