#include<stdio.h>
#include<stdlib.h>
#include "types.h"
#include "defaults.h"
#include "warning.h"
#include "pin.h"
#include "X.h"
#include "window.h"
#include "widget.h"
#include "hash.h"
#include "edit.h"
#include "post.h"
#include "misc.h"
#include "loop.h"
#include "languages.h"
#include "gsl.h"
#include "predmet.h"
#include "output.h"
#include "bindings.h"

kq_postava *ovlpost = NULL;

struct keybind{
  void (*funkce)();
  kq_pin parametr;
};

void grestart ()
{
  if(popup_info("_restart?")) kql_restart();
}

void popup_help (char *label)
{
  popup_info(label);
}

static void zmensmer (int smer)
{
  int xx, yy;

  if(!ovlpost) return;

  if(smer == LENA || smer == VLEVO || smer == LEDO) xx = -1;
  else if(smer == PRANA || smer == VPRAVO || smer == PRADO) xx = 1;
  else xx = 0;

  if(smer == LENA || smer == NAHORU || smer == PRANA) yy = -1;
  else if(smer == LEDO || smer == DOLU || smer == PRADO) yy = 1;
  else yy = 0;

  if(xx == ovlpost->xx && yy == ovlpost->yy){
    ovlpost->xx = 0;
    ovlpost->yy = 0;
  }
  else{
    ovlpost->xx = xx;
    ovlpost->yy = yy;
  }
}

void initbindings ()
{
  addgbind("F1", popup_help, pinpointer("_help"));
  addgbind("F2", gsave, pinnull);
  addgbind("F3", gload, pinnull);
  addgbind("F4", grestart, pinnull);
  addgbind("F5", zmenFPS, pinint(1));
  addgbind("F6", zmenFPS, pinint(-1));
  addgbind("F7", zmenratio, pinint(-1));
  addgbind("F8", zmenratio, pinint(1));
  addgbind("F9", ukazinv, pinnull);
  addgbind("F10", popup_help, pinpointer("_about"));
  addgbind("F11", fullscreen, pinnull);
  addgbind("F12", zobrazjazyky, pinnull);
  addgbind("Return",   text_enter, pinnull);
  addgbind("KP_Enter", text_enter, pinnull);

  addbind(BINDWIN, "Escape", kql_exit, pinnull);

  addbind(BINDWIN, "BackSpace", zkoumejhist, pinint(1));
  addbind(BINDWIN, "KP_End",    zmensmer, pinint(LEDO));
  addbind(BINDWIN, "KP_1",      zmensmer, pinint(LEDO));
  addbind(BINDWIN, "KP_Down",   zmensmer, pinint(DOLU));
  addbind(BINDWIN, "KP_2",      zmensmer, pinint(DOLU));
  addbind(BINDWIN, "Down",      zmensmer, pinint(DOLU));
  addbind(BINDWIN, "KP_Next",   zmensmer, pinint(PRADO));
  addbind(BINDWIN, "KP_3",      zmensmer, pinint(PRADO));
  addbind(BINDWIN, "KP_Left",   zmensmer, pinint(VLEVO));
  addbind(BINDWIN, "KP_4",      zmensmer, pinint(VLEVO));
  addbind(BINDWIN, "Left",      zmensmer, pinint(VLEVO));
  addbind(BINDWIN, "KP_Right",  zmensmer, pinint(VPRAVO));
  addbind(BINDWIN, "KP_6",      zmensmer, pinint(VPRAVO));
  addbind(BINDWIN, "Right",     zmensmer, pinint(VPRAVO));
  addbind(BINDWIN, "KP_Home",   zmensmer, pinint(LENA));
  addbind(BINDWIN, "KP_7",      zmensmer, pinint(LENA));
  addbind(BINDWIN, "KP_Up",     zmensmer, pinint(NAHORU));
  addbind(BINDWIN, "KP_8",      zmensmer, pinint(NAHORU));
  addbind(BINDWIN, "Up",        zmensmer, pinint(NAHORU));
  addbind(BINDWIN, "KP_Prior",  zmensmer, pinint(PRANA));
  addbind(BINDWIN, "KP_9",      zmensmer, pinint(PRANA));

  addbind(BINDWIN,  "Tab", prepniokraj, pinint(1));
  addbind(BINDTEXT, "Tab", prepniokraj, pinint(0));

  addbind(BINDTEXT, "Delete",    (void (*)())delete, pinint(0));
  addbind(BINDTEXT, "KP_Delete", (void (*)())delete, pinint(0));
  addbind(BINDTEXT, "BackSpace", (void (*)())delete, pinint(1));

  addbind(BINDTEXT, "Left",      posunkursor, pinint(0));
  addbind(BINDTEXT, "KP_Left",   posunkursor, pinint(0));
  addbind(BINDTEXT, "Right",     posunkursor, pinint(1));
  addbind(BINDTEXT, "KP_Right",  posunkursor, pinint(1));
  addbind(BINDTEXT, "Home",      posunkursor, pinint(2));
  addbind(BINDTEXT, "KP_Home",   posunkursor, pinint(2));
  addbind(BINDTEXT, "End",       posunkursor, pinint(3));
  addbind(BINDTEXT, "KP_End",    posunkursor, pinint(3));

  addbind(BINDTEXT, "Down",      zkoumejhist, pinint(0));
  addbind(BINDTEXT, "KP_Down",   zkoumejhist, pinint(0));
  addbind(BINDTEXT, "Up",        zkoumejhist, pinint(1));
  addbind(BINDTEXT, "KP_Up",     zkoumejhist, pinint(1));
  addbind(BINDTEXT, "Next",      zkoumejhist, pinint(2));
  addbind(BINDTEXT, "KP_Next",   zkoumejhist, pinint(2));
  addbind(BINDTEXT, "Prior",     zkoumejhist, pinint(3));
  addbind(BINDTEXT, "KP_Prior",  zkoumejhist, pinint(3));

  addbind(BINDTEXT, "Escape",   text_escape, pinnull);
}

void addbind (int typ, char *s, void (*funkce)(),
	      kq_pin parametr)
{
  struct keybind *b;
  kq_pin p;

  b=(struct keybind *)malloc(sizeof(struct keybind));
  b->funkce = funkce;
  b->parametr = parametr;
  p = pinpointer(b);
  hash_add(typ, s, &p);
}

void addgbind (char *s, void (*funkce)(),
	      kq_pin parametr)
{
  addbind(BINDWIN, s, funkce, parametr);
  addbind(BINDTEXT, s, funkce, parametr);
}

int dobind (char *s)
{
  struct keybind *b;
  kq_pin *p;

  if(okrajtext) p = hash_find(BINDTEXT, s);
  else p = hash_find(BINDWIN, s);
  if(!p) return 0;
  if(p->typ != PINPOINTER){
    warning("Klavesova zkratka ma spatny typ.");
    return 0;
  }
  b=p->u.p;
  spustsparem(b->funkce, &(b->parametr));
  return 1;
}
