#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include<stdarg.h>
#include "types.h"
#include "mystring.h"

//: initstr

void initstr (kq_string *str)
{
  str->posledni = NULL;
  str->delka = 0;
}

//: smazstr

void smazstr (kq_string *str)
{
  struct caststr *pom, *pomo;

  for(pom = str->posledni; pom; pom = pomo){
    pomo = pom->next;
    free(pom);
  }
  initstr(str);
}

//: zapisznak

void zapisznak (char ch, kq_string *str)
{
  struct caststr *pom;

  if(str->delka%STRDELKA == 0){
    pom = (struct caststr *)malloc(sizeof(struct caststr));
    pom->next = str->posledni;
    str->posledni = pom;
  }
  str->posledni->ch[str->delka%STRDELKA] = ch;

  str->delka++;
}

//: zestringuj

char *zestringuj (kq_string *str)
{
  int i, j;
  struct caststr *pom;
  char *vysledek;

  vysledek = (char *)malloc((str->delka+1)*sizeof(char));

  i = str->delka-1;
  i /= STRDELKA;
  i *= STRDELKA;
  j = str->delka - i;

  for(pom = str->posledni; pom; pom = pom->next){
    strncpy(&vysledek[i], pom->ch, j);
    j = STRDELKA;
    i -= STRDELKA;
  }
  vysledek[str->delka] = 0;

  return vysledek;
}

//: dupnstr

char *dupnstr (char *src, int n)
{
  char *vysledek;

  vysledek = malloc((n+1)*sizeof(char));
  strncpy(vysledek, src, n);
  vysledek[n] = 0;

  return vysledek;
}

//: joinstrings

char *joinstrings(char *prvni, ...)
{
  va_list vl;
  char *pomstr, *vysledek;
  int i=1;

  va_start(vl, prvni);
  for(pomstr=prvni; pomstr; pomstr = va_arg(vl, char *)){
    i += strlen(pomstr);
  }
  va_end(vl);  

  vysledek = (char *)malloc(i*sizeof(char));

  i=0;
  va_start(vl, prvni);
  for(pomstr=prvni; pomstr; pomstr = va_arg(vl, char *)){
    strcpy(&vysledek[i], pomstr);
    i += strlen(pomstr);
  }
  if(!prvni) vysledek[0] = 0;

  return vysledek;
}

//: zmensipism

char zmensipism (char ch)
{
  if(isalpha(ch)) return tolower(ch);
  else return ' ';
}

//: upravstring

void upravstring (char *str)
{
  int k,l,m;

  for(m=l=k=0; str[k]; k++){
    str[l] = zmensipism(str[k]);
    if(m==0){
      if(str[l] != ' '){
	m=1;
	l++;
      }
    }
    else{
      if(str[l] == ' ') m=0;
      l++;
    }
  }
  if(l > 0 && str[l-1] == ' ') str[l-1] = 0;
  else str[l] = 0;
}
